<ng-container [ngSwitch]="downloadStatus">
  <ng-container *ngSwitchCase="downloadStatuses.NOT_INITIATED">
    <dsfr-button
      [class.mobile-formats-menu-open]="isMobileFormatsMenuOpen"
      [label]="'Exporter la liste' + (isAFilterSelected() ? ' filtrée' : '')"
      icon="fr-icon-download-line"
      [size]="elementSizes.SMALL"
      [type]="buttonTypes.TERTIARY_NO_OUTLINE"
      cdkOverlayOrigin
      #trigger="cdkOverlayOrigin"
      (buttonClicked)="onExportButtonClicked()"
      (clickOutside)="isDesktopFormatsMenuOpen = false"></dsfr-button>

    <ng-template
      cdkConnectedOverlay
      [cdkConnectedOverlayOrigin]="trigger"
      [cdkConnectedOverlayOpen]="isDesktopFormatsMenuOpen">
      <ng-container [ngTemplateOutlet]="formatsMenuTemplate"></ng-container>
    </ng-template>

    <div *ngIf="isMobileFormatsMenuOpen">
      <ng-container [ngTemplateOutlet]="formatsMenuTemplate"></ng-container>
    </div>
  </ng-container>
  <ng-container *ngSwitchCase="downloadStatuses.INITIATED">
    <span class="downloading-label">Préparation du téléchargement ...</span>
  </ng-container>
  <ng-container *ngSwitchCase="downloadStatuses.READY">
    <div id="download-ready-display">
      <p>Le document est prêt à être téléchargé</p>
      <dsfr-button
        label="Télécharger"
        icon="fr-icon-download-line"
        (buttonClicked)="onDownloadReportsClicked()"
        [size]="elementSizes.SMALL"
        [type]="buttonTypes.SECONDARY"></dsfr-button>
    </div>
  </ng-container>
</ng-container>

<ng-template #formatsMenuTemplate>
  <div id="formats-export-menu">
    <p>Choisir un format</p>
    <ul>
      <li (click)="initiateDownload(exportFormats.XLSX)">.XLSX (Excel)</li>
      <li (click)="initiateDownload(exportFormats.CSV)">.CSV</li>
    </ul>
  </div>
</ng-template>
